`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    18:42:08 04/07/2016 
// Design Name: 
// Module Name:    fsm 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
`define STAT_DEF 1'b0 
`define STAT_ADD 1'b1
`define STAT_PAUSE 1'b0
`define DISABLED 1'b0
`define ENABLED 1'b1
module fsm(
	add_enable, // if adder is enabled 
	add, //input control
	clk, // global clock signal
	rst_n // low active reset
	);
	
	// outputs
	output add_enable; // if adder is enabled 
	
	// inputs
	input clk; // global clock signal
	input rst_n; // low active reset
	input add; //input control
	
	reg add_enable; // if adder is enabled
	reg state; // state of FSM
	reg next_state; // next state of FSM
	
	// FSM state decision
	always @*
		case(state)
		`STAT_DEF:
		if(add)
		begin
		 next_state=`STAT_ADD;
		 add_enable=`ENABLED;
		end
		else
		begin
		 next_state=`STAT_DEF;
		 add_enable=`DISABLED;
		end
		
		`STAT_ADD:
		if(add)
		begin
		 next_state=`STAT_PAUSE;
		 add_enable=`DISABLED;
		end
		else
		begin
		 next_state=`STAT_ADD;
		 add_enable=`ENABLED;
		end
		
		`STAT_PAUSE:
		if(add)
		begin
		 next_state=`STAT_ADD;
		 add_enable=`ENABLED;
		end
		else
		begin
		 next_state=`STAT_PAUSE;
		 add_enable=`DISABLED;
		end
		
		default:
		begin
		 next_state=`STAT_DEF;
		 add_enable=`DISABLED;
		end
		endcase
		
	// FSM state transition
	always@(posedge clk or negedge rst_n)
	if(~rst_n)
	 state<=`STAT_DEF;
	else
	 state<=next_state;

endmodule
