`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    01:33:19 04/10/2016 
// Design Name: 
// Module Name:    lab06_2 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module lab06_2(
	  clk, // scan clock
	  rst_n, // active low reset
	  col_n, // pressed_detected col_numn index
	  add_signal,//add botton
	  row_n, // scanned row_n index
	  pressed, // whether key_detected pressed_detected (1) or not (0)
	  ftsd_ctl, // 14-segment display scan control
	  display // 14-segment display
    );
	input clk; // clock from crystal oscillator
	input rst_n; // active low reset
	input [3:0] col_n; // pressed column index
	input add_signal;//add botton

	output [3:0] row_n;  // scanned row index
	output [14:0] display; // 14-segment display
	output [3:0] ftsd_ctl; // 14-segment display scan control
	output pressed; // whether keypad pressed (1) or not (0)
	
	// Declare internal nodes
	wire clk_debounce;
	wire [3:0] key0, key1; 
	wire [3:0] s;
	wire Cout; // pressed key
	wire [1:0] ftsd_ctl_en;
	wire [3:0] ftsd_in;
	wire add_debounce;
	wire add;
	wire add_enable;
	
	// Frequency divider
	freq_div U1(
	  .clk(clk), // clock from the 40MHz oscillator
	  .rst_n(rst_n), // low active reset
	  .clk_out(clk_debounce), //divided clock output	  
	  .clk_ctl(ftsd_ctl_en) // divided clock for 14-segment display scan
	);

	//FSM
	fsm U2(
		.add_enable(add_enable),
		.add(add),
		.clk(clk_debounce),
		.rst_n(rst_n)
		 );

	//keypad scan
	keypad_scan U3(
	  .clk(clk_debounce),
	  .rst_n(rst_n), // active low reset
	  .col_n(col_n), // pressed_detected col_numn index
	  .row_n(row_n), // scanned row_n index
	  .key0(key0), // returned pressed_detected key0
	  .key1(key1), // rsturned pressed_detected key1
	  .pressed(pressed), // whether key_detected pressed_detected (1) or not (0)
	  .add_enable(add_enable)
	);

	//Adder
	decimal_adder U4(
		 .a(key0),
		 .b(key1),
		 .s(s),
		 .cin(1'b0),
		 .cout(Cout)
		 );
		 
	// Scan control
	scan_ctl U5(
	  .in0(key0), // 1st input
	  .in1(key1), // 2nd input
	  .in2(Cout), // 3rd input
	  .in3(s),  // 4th input
	  .ftsd_ctl_en(ftsd_ctl_en), // divided clock for scan control
	  .ftsd_ctl(ftsd_ctl), // ftsd display control signal
	  .ftsd_in(ftsd_in) // output to ftsd display
	);

	//Display
	ftsd U6(
	  .bcd(ftsd_in),  // binary input
	  .display(display) // 14-segment display output
	);

	//About add input
	debounce_circuit U7(
	  .clk(clk_debounce), // clock control
	  .rst_n(rst_n), // reset
	  .pb_in(add_signal), //push button input
	  .pb_debounced(add_debounce) // debounced push button output
	);
	one_pulse U8(
	  .clk(clk_debounce),  // clock input
	  .rst_n(rst_n), //active low reset
	  .in_trig(add_debounce), // input trigger
	  .out_pulse(add) // output one pulse 
	);


endmodule
